#define idstart 0x80
#define idend 0x8e

main(argc,argv)
int argc;
char *argv[];
{
int file;
char header[256];
char pntr;
long leftshift,accum;
int i;
long leftshift;
long c;

	if(argc<2)
	{
		puts("Use: ID <filename>\n");
		return;
	}

	file=fopen(argv[1],"r");
	if(!file)
	{
		printf("Cannot open %s\n",argv[1]);
		return 1;
	}

	read(file,header,256);
	read(file,header,256);

	fclose(file);

	pntr = idstart;

	while ((header[pntr++] != '-') && (pntr != idend));

	while ((header[pntr] == '0') && (pntr != idend)) pntr++;

	leftshift = 16;
	accum = 0;
	for (i = 0; i < 5; i++) {
		c = header[pntr++];
		if ((c >= '0') && (c <= '9'))
			accum |= ( (long) (c - '0')) << leftshift;
		else
			break;

		leftshift -= 4;
	}

	for(pntr=idstart ; pntr!=idstart+0x10 ; pntr+=2)
		accum += 256L*header[pntr] + header[pntr+1];

	accum <<= 16L;

	/* checksum out to 0x1e0 so we don't hit the magic patch */


	for(pntr=0 ; pntr!=0xe0 ; pntr+=2)
		accum += 256L*header[pntr] + header[pntr+1];

	printf("%s %08lx\n",argv[1],accum);
}
