#define IDBlock         ((long)0x100)

unsigned char *       bytePtr;
unsigned short *wordPtr;
short                   i;
unsigned char   c;
unsigned long   leftShift;
unsigned long   accum;

        bytePtr = (unsigned char *)(IDBlock + cartIDStart);     // point to
cart ID line

        while ((*bytePtr++ != '-') &&
                                ((long)bytePtr != cartIDEnd)) ;
// find 1st '-'

        while ((*bytePtr == '0') &&
                                ((long)bytePtr != cartIDEnd))
// skip leading zeros
                bytePtr++;

        leftShift = 16;
        accum = 0;
        for (i = 0; i < 5; i++) {
// ascii dec to bin
                c = *bytePtr++;
                if ((c >= '0') && (c <= '9'))
                        accum |= ( (long) (c - '0')) << leftShift;
                else
                        break;

                leftShift -= 4;
        }

        for (wordPtr = (unsigned short *)(IDBlock + cartIDStart);
// checksum cartID line
                        (long)wordPtr != IDBlock + cartIDStart + 0x10;
wordPtr++)
                accum += *wordPtr;
        accum <<= 16;
// move to MSW

        /* checksum out to 0x1e0 so we don't hit the magic patch */
        for (wordPtr = (unsigned short *)IDBlock;                       //
checksum IDBlock
                        wordPtr != (unsigned short *)(IDBlock + 0xe0);
wordPtr++)
                accum += *wordPtr;
